///////////////////////////////////////////////////////
// Item/ Objektdefinitionen

ACTION ITEM_Vegeta_Klein
{
MY.PASSABLE = ON;
MY.OVERLAY = ON;
//MY.NOFILTER = ON; // Sieht beschissen aus ( zu pickslig )
MY.TRANSPARENT = ON;
MY.ALPHA = 100;
MY.ALBEDO = 10;
MY.PAN = Random (360);
MY.MATERIAL = MAT_Z_Buffer;

	VEC_SET(TEMP, MY.POS);
	TEMP.Z -= 1000;
	TRACE_MODE = IGNORE_SPRITES + IGNORE_ME + IGNORE_PASSENTS + IGNORE_PASSABLE + IGNORE_MODELS;
		TRACE (MY.X, TEMP.X); MY.Z = TARGET.Z -MY.MIN_Z * MY.SCALE_Z;

MY.SCALE_X = 0.8 + (Random(4) / 10);
MY.SCALE_Y = MY.SCALE_X;
MY.SCALE_Z = MY.SCALE_X;

	ENT_CREATE ("shadow.tga", TARGET, FNCT_Vegeta_Schatten);
}

ACTION ITEM_Vegeta_Gross
{
MY.PASSABLE = ON;
MY.OVERLAY = ON;
MY.TRANSPARENT = ON;
MY.ALPHA = 100;
MY.ALBEDO = 10;
MY.PAN = Random (360);
MY.SKIN = INT(Random(3)) + 1;
MY.MATERIAL = MAT_Z_Buffer;

	VEC_SET(TEMP, MY.POS);
	TEMP.Z -= 1000;
	TRACE_MODE = IGNORE_SPRITES + IGNORE_ME + IGNORE_PASSENTS + IGNORE_PASSABLE + IGNORE_MODELS;
		TRACE (MY.X, TEMP.X); MY.Z = TARGET.Z -MY.MIN_Z * MY.SCALE_Z;

MY.SCALE_X = 1 + (Random(2) / 10);
MY.SCALE_Y = MY.SCALE_X;
MY.SCALE_Z = MY.SCALE_X;

	MY._SektorID = 20;
	// Eine Mapentity nach bedarf erschaffen lassen (Kollision)
//	YOU = ENT_CREATE ("shadow.tga", TARGET.X, FNCT_Vegeta_Schatten);
//	YOU._SektorID = 41;
//	YOU.DYNAMIC = OFF;
	YOU = ENT_CREATE ("Stamm_a.wmb", MY.X, NULL);
	YOU.DYNAMIC = OFF;

WAIT (1);
MY.DYNAMIC = OFF;
}

ACTION ITEM_Vegeta_Grass
{
MY._SektorID = 10;
MY.PASSABLE = ON;
MY.OVERLAY = ON;
MY.ALBEDO = 10;
MY.TRANSPARENT = ON;
MY.ALPHA = 100;
MY.PAN = Random(360);
MY._Main_Anim = Random(100);
ENT_ANIMATE (MY, "Base", MY._Main_Anim, ANM_CYCLE);

MY.AMBIENT += Random(32)-16;

	VEC_SET(TEMP, MY.POS);
	TEMP.Z -= 1000;
	TRACE_MODE = IGNORE_SPRITES + IGNORE_ME + IGNORE_PASSENTS + IGNORE_PASSABLE + IGNORE_MODELS;
		TRACE(MY.POS,temp); MY.Z = TARGET.Z -MY.MIN_Z * MY.SCALE_Z;

MY.SCALE_X = 2 + (Random(8) / 10);
MY.SCALE_Y = MY.SCALE_X;
MY.SCALE_Z = MY.SCALE_X;

TEMP = INT(Random(64));
WAIT (TEMP);

	WHILE (1) {
		IF (FNCT_OnScreen()) {
			MY._Main_Anim += 0.5 * TIME;
			MY._Main_Anim %= 100;
			ENT_ANIMATE (MY, "Base", MY._Main_Anim, ANM_CYCLE);
		} ELSE { WAITT (64); }
	WAIT (1);
	}
}

ACTION ITEM_Schmetterling
{
MY._SektorID = 100;
MY.PASSABLE = ON;
MY.PAN = Random(360);
MY._Alt_Anim1 = 20 + Random(12);

	IF (!SektorObjekt[6]) {
		VEC_SET(TEMP, MY.POS);
		TEMP.Z -= 1000;
		TRACE_MODE = IGNORE_SPRITES + IGNORE_ME + IGNORE_PASSENTS + IGNORE_PASSABLE + IGNORE_MODELS;
			TRACE(MY.POS,temp); MY.Z = TARGET.Z -MY.MIN_Z + Random(48);
	}

	VEC_NORMALIZE (MY.SCALE_X, 0.5);

	IF (INT(Random(2))) { MY.SCALE_X *= -1; MY._Main_Anim = 100; }

	WHILE (1) {
		MY.PAN += MY._Alt_Anim1 * MY.SCALE_X * TIME;
		MY.PAN %= 360;
		MY._TIMER += TIME;
		IF (MY._TIMER > 1.6) {
			MY._TIMER = NULL;
			IF (MY._Main_Anim == 100) { MY._Main_Anim = 0; } ELSE { MY._Main_Anim = 100; }
			ENT_ANIMATE (MY, "Base", MY._Main_Anim, NULL);
		}
	WAIT (1);
	}
}

ACTION ITEM_Eis_Fest
{
MY._charakter = 21;
}

ACTION ITEM_Schild
{
MY.SHADOW = ON;
MY.FAT = OFF;
MY.NARROW = ON;

MY.ENABLE_SCAN = ON;
MY.EVENT = EVNT_Schildtexte;

	VEC_SET(TEMP, MY.POS);
	TEMP.Z -= 1000;
	TRACE_MODE = IGNORE_SPRITES + IGNORE_ME + IGNORE_PASSENTS + IGNORE_PASSABLE + IGNORE_MODELS;
		TRACE(MY.POS,temp); MY.Z = TARGET.Z -MY.MIN_Z * MY.SCALE_Z;

WAIT (1);
MY.DYNAMIC = OFF;
}

ACTION ITEM_Stockwerk
{
IF (MY.UNLIT == ON) { MY.AMBIENT = 100; }
//MY.UNLIT = ON;
//MY.AMBIENT = 0;
MY._Stockwerk = MY.Skill1;
IF (MY.Skill4) { MY.MATERIAL = MAT_Z_Buffer; }
	WHILE (1) {
		MY.ALPHA = Alphadef[MY._Stockwerk];
		IF (MY.ALPHA == 100) { MY.TRANSPARENT = OFF; } ELSE { MY.TRANSPARENT = ON; }
		IF (!MY.ALPHA) { MY.INVISIBLE = ON; } ELSE { MY.INVISIBLE = OFF; }
//		WHILE (!PLAYER) { WAIT (1); }
//		IF ((PLAYER.Z > 32 + MY.Skill3 * 144) && (!MY.ALPHA)) { // Stock 128 + offset 48
//			MY.INVISIBLE = OFF;
//			MY.TRANSPARENT = ON;
//			WHILE (MY.ALPHA < 100) {
//				MY.ALPHA += 12.5 * TIME;
//			WAIT (1);
//			}
//			MY.TRANSPARENT = OFF;
//			MY.ALPHA = 100;
//		}
//		IF ((PLAYER.Z < 16 + MY.Skill3 * 144) && (MY.ALPHA == 100)) {
//			MY.TRANSPARENT = ON;
//			WHILE (MY.ALPHA > 0) {
//				MY.ALPHA -= 12.5 * TIME;
//			WAIT (1);
//			}
//			MY.TRANSPARENT = OFF;
//			MY.INVISIBLE = ON;
//			MY.ALPHA = 0;
//		}
	WAIT (1);
	}
}

function FNCT_Stockwerk()
{
	WHILE (ME) {
		MY.ALPHA = Alphadef[MY._Stockwerk];
		IF (MY.ALPHA == 100) { MY.TRANSPARENT = OFF; } ELSE { MY.TRANSPARENT = ON; }
		IF (!MY.ALPHA) { MY.INVISIBLE = ON; } ELSE { MY.INVISIBLE = OFF; }
	WAIT (1);
	}
}

ACTION ITEM_NurText
{
MY.INVISIBLE = ON;
MY.PASSABLE = ON;
MY.ENABLE_SCAN = ON;
MY.EVENT = EVNT_Schildtexte;

MY.DYNAMIC = OFF;
}

// Waren

ACTION ITEM_Kiste
{
MY.SHADOW = ON;
MY.NARROW = OFF;
MY.FAT = ON;
MY.SCALE_X = 1 + (Random(4)/10);
MY.SCALE_Y = MY.SCALE_X;
MY.SCALE_Z = MY.SCALE_X;
MY.PAN = Random(360);

MY.SKIN = INT(Random(6))+1;
MY.Skill3 = 0;
//IF (MY.Skill3 == 0) { MY.Skill3 = 60; }

	VEC_SET(TEMP.X, MY.X);
	TEMP.Z -= 1000;
	TRACE_MODE = IGNORE_SPRITES + IGNORE_ME + IGNORE_PASSENTS + IGNORE_PASSABLE + IGNORE_MODELS;
		TRACE(MY.X, TEMP.X); MY.Z = TARGET.Z -MY.MIN_Z * MY.SCALE_Z;

WAIT (1);
MY.DYNAMIC = OFF;
}

ACTION ITEM_Fass
{
MY.SHADOW = ON;
MY.NARROW = OFF;
MY.FAT = ON;
MY.SCALE_X = 1 + (Random(2)/10);
MY.SCALE_Y = MY.SCALE_X;
MY.SCALE_Z = MY.SCALE_X;
MY.PAN = Random(360);

MY.Skill3 = 0;
//IF (MY.Skill3 == 0) { MY.Skill3 = 70; }

	VEC_SET(TEMP.X, MY.X);
	TEMP.Z -= 1000;
	TRACE_MODE = IGNORE_SPRITES + IGNORE_ME + IGNORE_PASSENTS + IGNORE_PASSABLE + IGNORE_MODELS;
		TRACE(MY.X, TEMP.X); MY.Z = TARGET.Z -MY.MIN_Z * MY.SCALE_Z;

WAIT (1);
MY.DYNAMIC = OFF;
}

ACTION ITEM_Strohballen
{
MY.SHADOW = ON;
MY.NARROW = OFF;
MY.FAT = ON;
MY.SCALE_X = 1 + (Random(2)/10);
MY.SCALE_Y = MY.SCALE_X;
MY.SCALE_Z = MY.SCALE_X;
MY.PAN = Random(360);

MY.Skill3 = 0;
//IF (MY.Skill3 == 0) { MY.Skill3 = 90; }

	VEC_SET(TEMP.X, MY.X);
	TEMP.Z -= 1000;
	TRACE_MODE = IGNORE_SPRITES + IGNORE_ME + IGNORE_PASSENTS + IGNORE_PASSABLE + IGNORE_MODELS;
		TRACE(MY.X, TEMP.X); MY.Z = TARGET.Z -MY.MIN_Z * MY.SCALE_Z;

WAIT (1);
MY.DYNAMIC = OFF;
}

ACTION ITEM_Kleiteile
{
WAIT (1);
IF (MY.SKILL4) { WAIT (1); }
MY.SHADOW = ON;
MY.NARROW = OFF;
MY.FAT = ON;
MY.SCALE_X = 0.8 + (Random(2)/10);
MY.SCALE_Y = MY.SCALE_X;
MY.SCALE_Z = MY.SCALE_X;
MY.PAN = Random(360);

IF (MY.Skill3 == 60) { MY.SKIN = INT(Random(6))+1; }
MY.Skill3 = NULL;
MY.Skill4 = NULL;

	VEC_SET (TEMP.X, MY.X);
	TEMP.Z -= 1000;
		C_TRACE (MY.X, TEMP.X, IGNORE_ME);
	MY.Z = TARGET.Z -MY.MIN_Z * MY.SCALE_Z;

WAIT (1);
MY.DYNAMIC = OFF;
}

ACTION ITEM_Kerze
{
WAIT (2);
MY.PASSABLE = ON;
MY.PAN = Random(360);

	ME = ENT_CREATE ("Kerzef.mdl", MY.X, NULL);

	MY.FLARE = ON;
	MY.TRANSPARENT = ON;
	MY.ALPHA = 80;
	MY.BRIGHT = ON;
	MY.UNLIT = ON;
	MY.AMBIENT = 100;
	MY.NOFOG = ON;

	MY.LIGHTRED = 10;
	MY.LIGHTGREEN = 10;
	MY.LIGHTBLUE = 0;

	MY._winkel = Random(360);

	WHILE (1) {
		MY.LIGHTRANGE = MY.LIGHTRED * 16 + ABS(FSIN(total_frames * 3 + MY._winkel, 20) * COS(total_frames * 5.3 + MY._winkel));
		MY.SCALE_Z = MY.LIGHTRANGE / 100;
	WAIT (1);
	}
}

ACTION ITEM_Geschirr
{
MY.PASSABLE = ON;
MY.SKIN = INT(Random(4) + 1);

WAIT (1);
MY.DYNAMIC = OFF;
}

ACTION ITEM_SkinX
{
MY.PASSABLE = ON;
MY.SKIN = MY.Skill4;
MY.Skill4 = 0;

WAIT (1);
MY.DYNAMIC = OFF;
}

ACTION ITEM_Stat_pass
{
MY._SektorID = 1;
}

// Umgebung

ACTION ITEM_Zaun
{
MY.PASSABLE = ON;
MY.Skill3 = 0;
MY.SKIN = MY.SKILL4;
MY.SKILL4 = 0;
//MY.SKILL3 = 3;
MY._SektorID = 1;

MY.DYNAMIC = OFF;
}

ACTION ITEM_Holzbank
{
MY.PASSABLE = ON;
//MY.Skill3 = 110;
MY.SKIN = MY.SKILL4;
MY.SKILL4 = 0;
MY._SektorID = 1;

MY.ENABLE_SCAN = ON;
MY.EVENT = EVNT_Schildtexte;

MY.DYNAMIC = OFF;
}

ACTION ITEM_Tuere
{
MY._winkel = MY.PAN;
MY._charakter = 50;

MY._Aktion = 0;
MY.ENABLE_IMPACT = ON;
MY.EVENT = EVNT_Tuererkennung;
	WHILE (1) {
		IF (MY._Aktion) {

			IF (MY._Aktion == 1) {
				IF (MY.PAN < MY._winkel + 90) { MY.PAN += 8 * TIME; } ELSE { MY.PAN = MY._winkel + 90; MY._Aktion = 5; }
			}
			IF (MY._Aktion == 2) {
				IF (MY.PAN > MY._winkel - 90) { MY.PAN -= 8 * TIME; } ELSE { MY.PAN = MY._winkel - 90; MY._Aktion = 6; }
			}
	
			IF (MY._Aktion ==  9) {
				IF (MY.PAN < MY._winkel) { MY.PAN += 8 * TIME; } ELSE { MY.PAN = MY._winkel; MY._Aktion = 0; }
			}
			IF (MY._Aktion == 10) {
				IF (MY.PAN > MY._winkel) { MY.PAN -= 8 * TIME; } ELSE { MY.PAN = MY._winkel; MY._Aktion = 0; }
			}
	
			IF ((MY._Aktion > 4) && (MY._Aktion < 9)) {
				MY._TIMER += 1 * TIME;
				IF ((MY._TIMER > 72) && (MY._Aktion == 5)) { MY._Aktion = 10; MY._TIMER = 0;/* ENT_PLAYSOUND (ME, door_cl, 100); */}
				IF ((MY._TIMER > 72) && (MY._Aktion == 6)) { MY._Aktion =  9; MY._TIMER = 0;/* ENT_PLAYSOUND (ME, door_cl, 100); */}
			}

		}
	WAIT (1);
	}
}

ACTION ITEM_Statue
{
	IF (MY.Skill1) {
		MY._Stockwerk = MY.Skill1;
		FNCT_Stockwerk();
		MY.Skill1 = 0;
	}

	MY.U += 0.001;
	ENT_ANIMATE (ME, "Frame", 100, NULL);
}

ACTION ITEM_NPC_tot
{
	MY.U += 0.001;
	ENT_ANIMATE (ME, "Death", 100, NULL);
	WAIT (1);
	MY.DYNAMIC = OFF;
}

ACTION ITEM_Pfeilflug
{
	WHILE (1) {
		VEC_SET (TEMP.X, vector(70 * TIME, NULL, NULL));
		VEC_ROTATE (TEMP.X, MY.PAN);
		VEC_ADD (MY.X, TEMP.X);

		IF ((MY.X < - 512) || (MY.Y > 512)) {
			TEMP = Random(32) + 16;
			WAITT (TEMP);
			MY.X = Random(512);
			MY.Y = -Random(512);
		}
	WAIT (1);
	}
}

ACTION ITEM_Spawnpunkt
{
MY.PASSABLE = ON;
MY.INVISIBLE = ON;
// Aktionen
// 0 - Wartestellung
// 1 - Gespawned und wartet
// 2 - Im Schirm und darf nicht spawnen

WAIT (2);	// Initialisierung, kennt man ja...

	WHILE (1) {
		MY._TIMER = VEC_DIST (CAMERA.X, MY.X);
		IF (MY._TIMER > 1024) { IF (MY._Aktion == 2) { MY._Aktion = 0; } WAITT (4); continue; }

		IF (MY._Aktion == 0) {
			// Zu spawnende Gegner in Skill3 eintragen:
			IF (Globale[0] >= 5) { MY._Aktion = 2; WAITT (16); continue; }
			IF (MY.Skill3 ==  1) { ENT_CREATE ("skeletta.mdl", MY.X, NPC_Skelett_a); MY._Aktion = 1; Globale[0] += 1; WAITT (16); continue; }
			IF (MY.Skill3 ==  2) { ENT_CREATE ("skelettb.mdl", MY.X, NPC_Skelett_b); MY._Aktion = 1; Globale[0] += 1; WAITT (16); continue; }
			IF (MY.Skill3 ==  3) { ENT_CREATE ("skelettc.mdl", MY.X, NPC_Skelett_c); MY._Aktion = 1; Globale[0] += 1; WAITT (16); continue; }

			IF (MY.Skill3 == 11) { ENT_CREATE ("wespea.mdl", MY.X, NPC_Wespe_a); MY._Aktion = 1; Globale[0] += 1; WAITT (16); continue; }
			IF (MY.Skill3 == 12) { ENT_CREATE ("wespeb.mdl", MY.X, NPC_Wespe_b); MY._Aktion = 1; Globale[0] += 1; WAITT (16); continue; }

			IF (MY.Skill3 == 21) { ENT_CREATE ("reissera.mdl", MY.X, NPC_Reisser_a); MY._Aktion = 1; Globale[0] += 1; WAITT (16); continue; }
		}

// Reset auf 0 gibt es nur bei Entfernung des Gegners zur Kamera vom Gegner aus oder komplettloeschung

	WAITT (4);
	}
}

ACTION ITEM_Questspawn
{
MY.PASSABLE = ON;
MY.INVISIBLE = ON;
// Aktionen
// 0 - Wartestellung
// 1 - Gespawned und wartet
// 2 - Im Schirm und darf nicht spawnen

WAIT (2);	// Initialisierung, kennt man ja...

	WHILE (1) {
		MY._TIMER = VEC_DIST (CAMERA.X, MY.X);
		IF (MY._TIMER > 1024) { IF (MY._Aktion == 2) { MY._Aktion = 0; } WAITT (4); continue; }

		IF (MY._Aktion == 0) {
			// Zu spawnende Gegner in Skill3 eintragen:
			IF (MY.Skill3 ==  3) { ENT_CREATE ("skelettc.mdl", MY.X, NPC_Skelett_c); MY._Aktion = 1; Globale[0] += 1; WAITT (16); continue; }
		}

// Reset auf 0 gibt es nur bei Entfernung des Gegners zur Kamera vom Gegner aus oder komplettloeschung

	WAITT (4);
	}
}

ACTION ITEM_Ladenschild
{
MY._SektorID = 120;

MY.PASSABLE = ON;

	IF (SektorObjekt[6]) {
		MY.PAN  = SektorObjekt[3]; MY.TILT = SektorObjekt[4]; MY.ROLL = SektorObjekt[5];
		VEC_SCALE (MY.SCALE_X, SektorObjekt[8]);
	}

	WHILE (1) {
		MY._Main_Anim = 50 + FSIN(total_ticks * 5, 50);
		ENT_ANIMATE (MY, "default", MY._Main_Anim, NULL);
	WAIT (1);
	}
}


ACTION ITEM_Rotation
{
MY.SHADOW = ON;
	WHILE (1) {
		MY.PAN += TIME;
	WAIT (1);
	}
}

ACTION ITEM_MAPS
{
	WHILE (1) {
		IF (VEC_DIST(MY.X, CAMERA.X) < 3000) {
			MY.PASSABLE = OFF;
			MY.INVISIBLE = OFF;
		} ELSE {
			MY.PASSABLE = ON;
			MY.INVISIBLE = ON;
		}
	WAITT (8);
	}
}

ACTION ITEM_Schiff_a
{
FNCT_Bugwellen_Init(912);

MY.METAL = ON;
MY.PASSABLE = ON;

	WHILE (1) {
		MY._Main_Anim = 50 + FSIN(total_ticks, 50);
		ENT_ANIMATE (MY, "wind", MY._Main_Anim, NULL);
	WAIT (1);
	}
}

ACTION ITEM_Geister_a
{
MY._TIMER = Random(360);
ITEM_Runtersetzen_2();

MY.PASSABLE = ON;
MY.TRANSPARENT = ON;

MY._SektorID = 110;

	WHILE (1) {
		MY.ALPHA = MAX(FSIN(total_ticks + MY._TIMER, 30), 0);
	WAIT (1);
	}
}

ACTION ITEM_Schwimmend
{
MY.ENABLE_IMPACT = ON;
MY.ENABLE_BLOCK = ON;
MY.EVENT = EVNT_Abstossen;

MY._TIMER = Random(32);
MY.Skill3 = 0;
MY.Skill4 = 0;

MY._SektorID = 90;

	WHILE (1) {
		MY.Z = Globale[9];
//		MY.Z = FSIN(total_ticks, 4) + 56;

			MY._speed_n_save_X -= SIGN(MY._speed_n_save_X) * 0.05 * TIME;
			MY._speed_n_save_Y -= SIGN(MY._speed_n_save_Y) * 0.05 * TIME;
			IF (VEC_LENGTH(MY._speed_n_save_X) > 5) { VEC_NORMALIZE (MY._speed_n_save_X, 5); }

			VEC_SET (MY._SPEED_X, MY._speed_n_save_X);
			VEC_SCALE (MY._SPEED_X, TIME);
		
			MOVE_MODE = IGNORE_PASSABLE + IGNORE_PASSENTS;
				ENT_MOVE (NULLVECTOR, MY._SPEED_X);
		
			TEMP = 0.5 * MY._winkel * VEC_LENGTH(MY._speed_n_save_X) * TIME;
			MY.PAN += TEMP;

			MY._TIMER -= TIME;
			IF (MY._TIMER < 0) {
				MY._TIMER = 24 + Random(16);
				IF (FNCT_OnScreen()) { ENT_CREATE ("wellen1.mdl", MY.X, FNCT_Grosse_Wellen); }
			}
	WAIT (1);
	}
}

ACTION ITEM_Boot_a
{
MY._Str = 1;
MY.PASSABLE = ON;
YOU = ENT_CREATE ("coli_bot.wmb", MY.X, NULL);
YOU._Str = 1;
YOU.PAN = MY.PAN;

	WHILE (1) {
		MY.Z = Globale[9];
		MY.TILT = FSIN(total_ticks * 2.6, 1);
		MY.ROLL = FSIN(total_ticks * 3.1, 2);
	WAIT (1);
	}
}

function Wasser()
{
WAIT (3);
ME = ENT_CREATE ("Wasser.wmb", NULLVECTOR, NULL);
MY._Glanz = ENT_CREATE ("Himmel.wmb", NULLVECTOR, NULL);
turb_speed = 0.25;

Wasserebene = ME;

MY.PASSABLE = ON;
MY.TRANSPARENT = ON;
MY.ALPHA = 25;
MY._charakter = 20;

MY.X = CAMERA.X;
MY.Y = CAMERA.Y;
MY._SPEED_X = MY.X;
MY._SPEED_Y = MY.Y;

YOU = MY._Glanz;

YOU.PASSABLE = ON;
YOU.FLARE = ON;
YOU.TRANSPARENT = ON;
YOU.ALPHA = 35;
YOU._charakter = 20;

YOU.X = CAMERA.X;
YOU.Y = CAMERA.Y;

	WHILE (1) {
		MY.X = CAMERA.X;
		MY.Y = CAMERA.Y - 16;
		MY.Z = Globale[9] - 56;
		MY.U += (CAMERA.X - MY._SPEED_X + FSIN(total_ticks * 2.1, 0.2)) * 0.5 + Wasserbewegung.X * TIME;
		MY._SPEED_X = CAMERA.X;
		MY.V += (MY._SPEED_Y - CAMERA.Y + FCOS(total_ticks * 2.9, 0.1)) * 0.5 + Wasserbewegung.Y * TIME;
		MY._SPEED_Y = CAMERA.Y;

		YOU = MY._Glanz;
		VEC_SET (YOU.X, MY.X);
		MY.Z = YOU.Z + 0.25;
		YOU.U += ((Wind[0] + Wasserbewegung.X) * 0.15) * TIME;
		YOU.V += ((Wind[1] + Wasserbewegung.Y) * 0.15) * TIME;
	WAIT (1);
	}
}

ACTION ITEM_Felsen
{
	MY._SektorID = 1;
	VEC_SET(TEMP, MY.X);
	TEMP.Z -= 1000;
	TRACE_MODE = IGNORE_SPRITES + IGNORE_ME + IGNORE_PASSENTS + IGNORE_PASSABLE + IGNORE_MODELS;
		TRACE(MY.X, TEMP.X); MY.Z = TARGET.Z - (MY.MIN_Z * MY.SCALE_Z * (normal.Z - 0.1));

	MY.SKIN = INT(Random(4)) + 1;

	IF (MY.Skill3 == 1) { YOU = ENT_CREATE ("fels_a.wmb", MY.X, NULL); }
	IF (MY.Skill3 == 2) { YOU = ENT_CREATE ("fels_b.wmb", MY.X, NULL); }
	IF (MY.Skill3 == 3) { YOU = ENT_CREATE ("fels_c.wmb", MY.X, NULL); }
	IF (MY.Skill3 == 4) { YOU = ENT_CREATE ("fels_d.wmb", MY.X, NULL); }
	IF (MY.Skill3 == 5) { YOU = ENT_CREATE ("fels_e.wmb", MY.X, NULL); }
	IF (YOU) { YOU.PAN = MY.PAN; }
	MY.Skill3 = 0;

WAIT (1);
MY.DYNAMIC  = OFF;
IF (YOU) { YOU.DYNAMIC = OFF; }
}

ACTION ITEM_Steinspawn
{
	WHILE (MY._TIMER < 10) {
		MY._TIMER += 1;
		VEC_SET (TEMP.X, MY.X);
		TEMP.X += Random(1024) - 512;
		TEMP.Y += Random(1024) - 512;
		VEC_SET (MY._SPEED_X, TEMP.X); MY._SPEED_Z -= 1000;
		TRACE_MODE = IGNORE_ME + IGNORE_PASSABLE + IGNORE_SPRITES;
			RESULT = TRACE (TEMP.X, MY._SPEED_X);

		IF (RESULT) { IF (YOU) {
			IF ((!YOU._charakter) || (YOU._charakter == 19)) {
				TARGET.Z += 1;
				YOU = ENT_CREATE ("stein_a.mdl", TARGET.X, NULL);
				YOU.PAN = Random(360);
				YOU.PASSABLE = ON;
				YOU._SektorID = 1;
				WAIT (1);
				YOU.DYNAMIC = OFF;
			}
		} }
	}
ENT_REMOVE (ME);
RETURN;
}

ACTION ITEM_Ortsbesch
{
MY.INVISIBLE = ON;
MY.PASSABLE = ON;
TEMP = INT(Random(8));
WAIT (TEMP);
	WHILE (1) {
		IF (FNCT_OnScreen()) {
			IF (!MY._Aktion) {
				IF (!STR_LEN(Level_String)) {
					MY._Aktion = 1;
					IF (MY.Skill4 ==   3) { STR_CPY (Level_String, SOrt_3); }
					IF (MY.Skill4 ==   5) { STR_CPY (Level_String, SOrt_5); }
					IF (MY.Skill4 ==  10) { STR_CPY (Level_String, SOrt_10); }
					IF (MY.Skill4 ==  11) { STR_CPY (Level_String, SOrt_11); }
					IF (MY.Skill4 ==  12) { STR_CPY (Level_String, SOrt_12); }
				}
			}
		} ELSE { IF (MY._Aktion) { WAITT (80); MY._Aktion = 0; } }
	WAIT (8);
	}
}

ACTION ITEM_Runtersetzen_1
{
	VEC_SET(TEMP, MY.X);
	TEMP.Z -= 1000;
	TRACE_MODE = IGNORE_SPRITES + IGNORE_ME + IGNORE_PASSENTS + IGNORE_PASSABLE + IGNORE_MODELS;
		TRACE(MY.X, TEMP.X); MY.Z = TARGET.Z;

WAIT (1);
MY.DYNAMIC = OFF;
}

ACTION ITEM_Runtersetzen_2
{
	VEC_SET(TEMP, MY.X);
	TEMP.Z -= 1000;
	TRACE_MODE = IGNORE_SPRITES + IGNORE_ME + IGNORE_PASSENTS + IGNORE_PASSABLE + IGNORE_MODELS;
		TRACE(MY.X, TEMP.X); MY.Z = TARGET.Z - MY.MIN_Z;

WAIT (1);
MY.DYNAMIC = OFF;
}

ACTION ITEM_Levelkollision
{
MY.PASSABLE = ON;
WAITT (6);
MY.PASSABLE = OFF;

MY.DYNAMIC = OFF;
}

ACTION ITEM_Fogspawn_1
{
MY.INVISIBLE = ON;
MY.PASSABLE = ON;
MY._Str = 1;
	WHILE (1) {
		TEMP.X = CAMERA.X - MY.X;
		TEMP.Y = CAMERA.Y - MY.Y;
		TEMP.Z = 0;
		MY._Limit = 1000 - VEC_LENGTH(TEMP.X) * 0.25;
		Tageszeiten[11] = MIN(500, (MAX(MY._Limit, 0)));
	WAIT (1);
	}
}

// Truhen und andere Gegenstaende
ACTION ITEM_Schwert_a
{
//IF (Quests[102]) { ENT_REMOVE (MY); RETURN; }
IF (Waffen[0] >= SWRT_1) { ENT_REMOVE (MY); RETURN; }

MY._charakter = 100;
MY.PASSABLE = ON;

MY.ENABLE_SCAN = ON;
MY.EVENT = EVNT_DMG_Zuweisung;
}

ACTION ITEM_Klaue_a
{
IF (Waffen[1] >= KLAU_1) { ENT_REMOVE (MY); RETURN; }

MY._charakter = 101;
MY.PASSABLE = ON;

MY.ENABLE_SCAN = ON;
MY.EVENT = EVNT_DMG_Zuweisung;
}

ACTION ITEM_Bogen_a
{
IF (Waffen[2] >= BOGN_1) { ENT_REMOVE (MY); RETURN; }

MY._charakter = 102;
MY.PASSABLE = ON;

	WAIT (5);

	VEC_SET (TEMP, MY.X);
	TEMP.Z -= 1000;
		C_TRACE (MY.X, TEMP.X, IGNORE_ME);
	MY.Z = TARGET.Z + 8;

MY.ENABLE_SCAN = ON;
MY.EVENT = EVNT_DMG_Zuweisung;
}

ACTION ITEM_Keule_a
{
//IF (Quests[102]) { ENT_REMOVE (MY); RETURN; }
IF (Waffen[4] >= KEUL_1) { ENT_REMOVE (MY); RETURN; }

MY._charakter = 103;
MY.PASSABLE = ON;

MY.ENABLE_SCAN = ON;
MY.EVENT = EVNT_DMG_Zuweisung;
}

ACTION ITEM_Levelwechsel
{
MY.INVISIBLE = ON;
MY.PASSABLE = ON;
MY._charakter = 55;

MY.ENABLE_SCAN = ON;
MY.EVENT = EVNT_DMG_Zuweisung;

TEMP_ENT = ME;

	IF (MY.Skill3) {
		ME = ENT_CREATE("lvl_a.mdl", TEMP_ENT.X, NULL);
		MY.PASSABLE = ON;
		MY.TRANSPARENT = ON;
		MY.BRIGHT = ON;
		MY.UNLIT = ON;
		MY.NOFOG = ON;
		MY.AMBIENT = 100;
		MY._charakter = 55;
		Lichtschein(TEMP_ENT.Skill5, TEMP_ENT.Skill6);
		
		YOU = ENT_CREATE("lvl_a.mdl", TEMP_ENT.X, NULL);
		YOU.PASSABLE = ON;
		YOU.TRANSPARENT = ON;
		YOU.BRIGHT = ON;
		YOU.UNLIT = ON;
		YOU.NOFOG = ON;
		YOU.AMBIENT = 100;
		YOU._charakter = 55;

		MY._TIMER = 8;
		YOU._TIMER = 4;

		WHILE (1) {

			MY._TIMER -= 0.5 * TIME;
			YOU._TIMER -= 0.5 * TIME;
			IF (MY._TIMER < 0.1) { MY._TIMER = 8; }
			IF (YOU._TIMER < 0.1) { YOU._TIMER = 8; MY._TIMER = 4; }
			MY.ALPHA = FSIN(MY._TIMER * 22.5, 50);
			YOU.ALPHA = FSIN(YOU._TIMER * 22.5, 50);
			VEC_NORMALIZE (MY.SCALE_X, MY._TIMER);
			VEC_NORMALIZE (YOU.SCALE_X, YOU._TIMER);

			MY._winkel += TIME;
			IF (MY._winkel > 1) {
				MY._winkel = NULL;
				IF (FNCT_OnScreen) {
					Effect (Effekt_Strudel_Weiss, 1, MY.X, NULLVECTOR);
				}
			}

		WAIT (1);
		}
	}

MY.DYNAMIC = OFF;
}

ACTION ITEM_Quest_Obj_1
{
IF (Quests[131] >= 2) { ENT_REMOVE (MY); RETURN; }

MY._charakter = 131;

MY.EVENT = EVNT_DMG_Zuweisung;
	WHILE (1) {
		IF (!Quests[131]) { MY.INVISIBLE = ON; MY.PASSABLE = ON; MY.ENABLE_SCAN = OFF;
		} ELSE {
			MY.INVISIBLE = OFF; MY.PASSABLE = OFF; MY.ENABLE_SCAN = ON;
			YOU = ENT_CREATE ("Flare1.bmp", MY.X, NULL);
			MY._Glanz = YOU;
			MY._TIMER = 0;
			YOU.TRANSPARENT = ON;
			YOU.FLARE = ON;
			YOU.BRIGHT = ON;
			YOU.PASSABLE = ON;
			YOU.FACING = ON;
			YOU.ROLL = Random(360);
			WHILE (YOU) {
				MY._TIMER += 10 * TIME;
				YOU.SCALE_X = SIN(MY._TIMER);
				YOU.SCALE_Y = YOU.SCALE_X;
				YOU.ALPHA = 80 * YOU.SCALE_X;
				IF (MY._TIMER > 180) { ENT_REMOVE (YOU); MY._Glanz = NULL; }
			WAIT (1);
			}
		}
	WAITT (32);
	}
}