// SektorIDs
// Statik
// 0-vollstatisch/impassable
// 1-vollstatisch/passable
// Vegetation
// 10-Grass
// 20 Baeume
// Sprites
// 40 Feuerflare
// 41 Baumschatten
// Objekte
// 80 Fackel klein
// 90 Item schwimmend
// 100 Schmetterlinge
// 110 Geister_a (Grabsteine ect.)
// 120 Ladenschild


function SEKT_stat_impass()
{
YOU = ENT_CREATE (TEMP_STRING, SektorObjekt.X, NULL);

YOU.PAN = SektorObjekt[3]; YOU.TILT = SektorObjekt[4]; YOU.ROLL = SektorObjekt[5];
VEC_SCALE (YOU.SCALE_X, SektorObjekt[8]);
WAIT (1); YOU.DYNAMIC = OFF;
ENT_REMOVE(ME);
}

function SEKT_stat_pass()
{
MY.PAN  = SektorObjekt[3]; MY.TILT = SektorObjekt[4]; MY.ROLL = SektorObjekt[5];
VEC_SCALE (MY.SCALE_X, SektorObjekt[8]);
MY.PASSABLE = ON; WAIT (1); MY.DYNAMIC = OFF;
}

function SEKT_Grass()
{
MY.PAN  = SektorObjekt[3]; MY.TILT = SektorObjekt[4]; MY.ROLL = SektorObjekt[5];
VEC_SCALE (MY.SCALE_X, SektorObjekt[8]);
MY.PASSABLE = ON; MY.ALBEDO = 10;
MY._Main_Anim = Random(100);
ENT_ANIMATE (MY, "Base", MY._Main_Anim, ANM_CYCLE);

MY.AMBIENT += Random(32)-16;

	WHILE (ME) {
		MY._Main_Anim += 0.5 * TIME;
		MY._Main_Anim %= 100;
		ENT_ANIMATE (MY, "Base", MY._Main_Anim, ANM_CYCLE);
	WAIT (1);
	}
}

function SEKT_Baum()
{
MY.PAN  = SektorObjekt[3]; MY.TILT = SektorObjekt[4]; MY.ROLL = SektorObjekt[5];
VEC_SCALE (MY.SCALE_X, SektorObjekt[8]);
MY.OVERLAY = ON;
MY.TRANSPARENT = ON;
MY.ALPHA = 100;
MY.PASSABLE = ON;
MY.ALBEDO = 10;
MY.PAN = Random (360);
MY.SKIN = SektorObjekt[6];

MY.MATERIAL = MAT_Z_Buffer;

WAIT (1); MY.DYNAMIC = OFF;
}

function SEKT_Feuer_Flare()
{
MY.PAN  = SektorObjekt[3]; MY.TILT = SektorObjekt[4]; MY.ROLL = SektorObjekt[5];
VEC_SCALE (MY.SCALE_X, SektorObjekt[8]);
MY.FACING = ON;
MY.PASSABLE = ON;
MY.TRANSPARENT = ON;
MY.ALPHA = 40;
MY.UNLIT = ON;
MY.AMBIENT = 100;
MY.NOFOG = ON;
MY.ROLL = Random(360);
}

function SEKT_Feuer_klein()
{
MY.PAN  = SektorObjekt[3]; MY.TILT = SektorObjekt[4]; MY.ROLL = SektorObjekt[5];
VEC_SCALE (MY.SCALE_X, SektorObjekt[8]);
MY._winkel = Random(360);
MY.LIGHTRED = 30;
MY.LIGHTGREEN = 30;
MY.LIGHTBLUE = 0;

	WHILE (ME) {
		IF (MY.INVISIBLE == OFF) {
			IF (FNCT_OnScreen()) {
				MY._TIMER += TIME;
				IF (MY._TIMER >= 2) {
					MY._TIMER %= 2;
					Effect (Feuer_Klein, 3, MY.X, NULLVECTOR);
					Effect (Rauch_Klein, 1, MY.X, NULLVECTOR);
					Effect (Feuer_Funken,1, MY.X, NULLVECTOR);
				}
				MY.LIGHTRANGE = MY.LIGHTRED * 4 + ABS(50*(SIN(total_frames * 13 + MY._winkel) * COS(total_frames*5 + MY._winkel)));
			} ELSE { MY.LIGHTRANGE = 0; }
		}
	WAIT (1);
	}
}

function SEKT_Schwimmend()
{
MY.PAN  = SektorObjekt[3]; MY.TILT = SektorObjekt[4]; MY.ROLL = SektorObjekt[5];
VEC_SCALE (MY.SCALE_X, SektorObjekt[8]);
MY.ENABLE_IMPACT = ON;
MY.ENABLE_BLOCK = ON;
MY.EVENT = EVNT_Abstossen;

MY._TIMER = Random(32);

	WHILE (ME) {
		MY.Z = Globale[9];

			MY._speed_n_save_X -= SIGN(MY._speed_n_save_X) * 0.05 * TIME;
			MY._speed_n_save_Y -= SIGN(MY._speed_n_save_Y) * 0.05 * TIME;
			IF (VEC_LENGTH(MY._speed_n_save_X) > 5) { VEC_NORMALIZE (MY._speed_n_save_X, 5); }

			VEC_SET (MY._SPEED_X, MY._speed_n_save_X);
			VEC_SCALE (MY._SPEED_X, TIME);
		
			MOVE_MODE = IGNORE_PASSABLE + IGNORE_PASSENTS;
				ENT_MOVE (NULLVECTOR, MY._SPEED_X);
		
			TEMP = 0.5 * MY._winkel * VEC_LENGTH(MY._speed_n_save_X) * TIME;
			MY.PAN += TEMP;

			MY._TIMER -= TIME;
			IF (MY._TIMER < 0) {
				MY._TIMER = 24 + Random(16);
				IF (FNCT_OnScreen()) { ENT_CREATE ("wellen1.mdl", MY.X, FNCT_Grosse_Wellen); }
			}
	WAIT (1);
	}
}

function SEKT_Schatten()
{
MY.UNLIT = ON;
MY.NOFOG = ON;
MY.TRANSPARENT = ON;
MY.PASSABLE = ON;
MY.ORIENTED = ON;

MY.PAN  = SektorObjekt[3]; MY.TILT = SektorObjekt[4]; MY.ROLL = SektorObjekt[5];
VEC_SCALE (MY.SCALE_X, SektorObjekt[8]);
}

function SEKT_Geister_a()
{
MY.PAN  = SektorObjekt[3]; MY.TILT = SektorObjekt[4]; MY.ROLL = SektorObjekt[5];
VEC_SCALE (MY.SCALE_X, SektorObjekt[8]);

MY._TIMER = Random(360);

MY.PASSABLE = ON;
MY.TRANSPARENT = ON;

	WHILE (1) {
		MY.ALPHA = MAX(FSIN(total_ticks + MY._TIMER, 30), 0);
	WAIT (1);
	}
}


function SEKT_Gleich_entfernen(du)
{
TEMP.Z = YOU._Str + YOU._Vit + YOU._Ges + YOU._Agi + YOU._Int + YOU._Wei + YOU._charakter;
IF (TEMP.Z) { RETURN; }
WAIT (1);
YOU = du;
ENT_REMOVE (YOU);
}


function SEKT_Datei_schreiben()
{
var sektor_count;

filehandle = FILE_OPEN_WRITE("Benezos.dat");

	WHILE (sektor_count.Y < Sektor_Y) {

		TEMP = (sektor_count.Y * Sektor_X) + sektor_count.X;
		STR_FOR_NUM (TEMP_STRING, TEMP);
		FILE_STR_WRITE (filehandle, "Sektor");
		FILE_STR_WRITE (filehandle, TEMP_STRING);
		FILE_ASC_WRITE (filehandle, 13);
		FILE_ASC_WRITE (filehandle, 10);

		YOU = ENT_NEXT (NULL);
		TEMP.X = Sektor_Q * ( sektor_count.X - (Sektor_X * 0.5));
		TEMP.Y = Sektor_Q * (-sektor_count.Y + (Sektor_Y * 0.5));

		WHILE (YOU) {
				TEMP.Z = YOU._Str + YOU._Vit + YOU._Ges + YOU._Agi + YOU._Int + YOU._Wei + YOU._charakter;
				IF (!TEMP.Z) {
					IF ((YOU.X >= TEMP.X) && (YOU.X < TEMP.X + Sektor_Q)) {
						IF ((YOU.Y <= TEMP.Y) && (YOU.Y > TEMP.Y - Sektor_Q)) {
							STR_FOR_ENTFILE(TEMP_STRING, YOU);
							FILE_STR_WRITE (filehandle, TEMP_STRING);
							FILE_STR_WRITE (filehandle, ",");
							FILE_VAR_WRITE (filehandle, YOU.X);
							FILE_VAR_WRITE (filehandle, YOU.Y);
							FILE_VAR_WRITE (filehandle, YOU.Z);
							FILE_VAR_WRITE (filehandle, YOU.PAN);
							FILE_VAR_WRITE (filehandle, YOU.TILT);
							FILE_VAR_WRITE (filehandle, YOU.ROLL);
							FILE_VAR_WRITE (filehandle, YOU.SKIN);
							FILE_VAR_WRITE (filehandle, YOU._SektorID);
							FILE_VAR_WRITE (filehandle, YOU.SCALE_X);
							FILE_ASC_WRITE (filehandle, 13);
							FILE_ASC_WRITE (filehandle, 10);
						}
					}
				}
		YOU = ENT_NEXT (YOU);
		}

//		PLAYER.X = TEMP.X;
//		PLAYER.Y = TEMP.Y;
		WAITT (1);

		sektor_count.X += 1;
		IF (sektor_count.X >= Sektor_X) {
			sektor_count.X = 0;
			sektor_count.Y += 1;
		}

	}

FILE_CLOSE (filehandle);
STR_CPY (SMS, "Fertig!");
}


function SEKT_Sektoranalyse()
{
var PrePastShow;

WAIT (3);	// Level laden lassen

//player.light=on;player.red=255;
ME = PLAYER;
TEMP = 0;
WHILE (TEMP < Sektormatrix.LENGTH) {
	Sektormatrix[TEMP] = 0;
	TEMP += 1;
}

//PrePastShow.X = INT((PLAYER.X + (0.5 * Sektor_X * Sektor_Q)) / Sektor_Q);
//PrePastShow.Y = Sektor_X - INT((PLAYER.Y + (0.5 * Sektor_Y * Sektor_Q)) / Sektor_Q) - 1;
PrePastShow.X = Sektor_X;

	WHILE (!Quests[1]) {	// Quests[1] == 0
		TEMP.X = INT((CAMERA.X + (0.5 * Sektor_X * Sektor_Q)) / Sektor_Q);
		TEMP.Y = Sektor_X - INT((CAMERA.Y + (0.5 * Sektor_Y * Sektor_Q)) / Sektor_Q) - 1;

		IF ((TEMP.X != PrePastShow.X) || (TEMP.Y != PrePastShow.Y)) {
			show_sekt_load.VISIBLE = ON;
			PrePastShow.X = TEMP.X;
			PrePastShow.Y = TEMP.Y;
			WAIT (1);	// Panel sichtbar machen
//			TEMPs.X = TEMP.X;
//			TEMPs.Y = TEMP.Y;
//			TEMPs.Z = PrePastShow.Y * Sektor_X + PrePastShow.X;

//			TEMP.X = -(0.5 * Sektor_X * Sektor_Q) + (0.5 * Sektor_Q) + (PrePastShow.X * Sektor_Q);
//			TEMP.Y =  (0.5 * Sektor_Y * Sektor_Q) - (0.5 * Sektor_Q) - (PrePastShow.Y * Sektor_Q);

			YOU = ENT_NEXT (NULL);
			Sektorobjekt[4] = Sektor_Q * 1.5;

			SektorObjekt[0] = -(0.5 * Sektor_X * Sektor_Q) + (PrePastShow.X + 0.5) * Sektor_Q - Sektorobjekt[4];
			SektorObjekt[1] = -(0.5 * Sektor_X * Sektor_Q) + (PrePastShow.X + 0.5) * Sektor_Q + Sektorobjekt[4];
			SektorObjekt[2] =  (0.5 * Sektor_Y * Sektor_Q) - (PrePastShow.Y + 0.5) * Sektor_Q - Sektorobjekt[4];
			SektorObjekt[3] =  (0.5 * Sektor_Y * Sektor_Q) - (PrePastShow.Y + 0.5) * Sektor_Q + Sektorobjekt[4];

			WHILE (YOU) {
				IF ((YOU.X <= SektorObjekt[0]) || (YOU.X > SektorObjekt[1])) { SEKT_Gleich_entfernen(YOU);
				} ELSE { IF ((YOU.Y <= SektorObjekt[2]) || (YOU.Y > SektorObjekt[3])) { SEKT_Gleich_entfernen(YOU); } }
			YOU = ENT_NEXT (YOU);
			}

			PrePastShow[2] = 0;
			WHILE (PrePastShow[2] < 9) {
				TEMP = PrePastShow.Y * Sektor_X + PrePastShow.X;
				IF (PrePastShow[2] == 0) { TEMP -= Sektor_X + 1; }
				IF (PrePastShow[2] == 1) { TEMP -= Sektor_X; }
				IF (PrePastShow[2] == 2) { TEMP -= Sektor_X - 1; }
				IF (PrePastShow[2] == 3) { TEMP -= 1; }
				IF (PrePastShow[2] == 5) { TEMP += 1; }
				IF (PrePastShow[2] == 6) { TEMP += Sektor_X - 1; }
				IF (PrePastShow[2] == 7) { TEMP += Sektor_X; }
				IF (PrePastShow[2] == 8) { TEMP += Sektor_X + 1; }

				IF ((TEMP >= 0) && (TEMP < Sektor_X * Sektor_Y)) {
					IF (!Sektormatrix[TEMP]) {
	
						Sektormatrix[TEMP] = 2;
		
						STR_FOR_NUM (TEMP_STRING, TEMP);
						STR_CPY (SEKTOR_STRING, "Sektor");
						STR_CAT (SEKTOR_STRING, TEMP_STRING);
		
						filehandle = FILE_OPEN_READ("Benezos.dat");
		
						WHILE (1) {	// SektorX suchen
							TEMP[1] = FILE_STR_READ (filehandle, TEMP_STRING);
							IF (TEMP[1] == -1) { break; }
							IF (STR_CMP(TEMP_STRING, SEKTOR_STRING)) {	// SektorX gefunden
								TEMP += 1;	// Bis zum naechsten Sektor (SektorX+1)
		
								STR_FOR_NUM (TEMP_STRING, TEMP);
								STR_CPY (SEKTOR_STRING, "Sektor");
								STR_CAT (SEKTOR_STRING, TEMP_STRING);
		
								WHILE (1) {	// Alle Objekte bis SektorX+1 auslesen und erschaffen
		
									TEMP[1] = FILE_STR_READ (filehandle, TEMP_STRING);
									IF ((STR_CMP (TEMP_STRING, SEKTOR_STRING)) || (TEMP[1] == -1)) { break; }
									TEMP[1] = 0;
									WHILE (TEMP[1] < SektorObjekt.LENGTH) {
										SektorObjekt[TEMP[1]] = FILE_VAR_READ (filehandle);
										TEMP[1] += 1;
									}

									IF (SektorObjekt[7] ==   0) { ENT_CREATE ("Flamme3.tga", SektorObjekt.X, SEKT_stat_impass); }
									IF (SektorObjekt[7] ==   1) { ENT_CREATE (TEMP_STRING, SektorObjekt.X, SEKT_stat_pass); }
									IF (SektorObjekt[7] ==  10) { ENT_CREATE (TEMP_STRING, SektorObjekt.X, SEKT_Grass); }
									IF (SektorObjekt[7] ==  20) { ENT_CREATE (TEMP_STRING, SektorObjekt.X, SEKT_Baum); }
									IF (SektorObjekt[7] ==  40) { ENT_CREATE (TEMP_STRING, SektorObjekt.X, SEKT_Feuer_Flare); }
									IF (SektorObjekt[7] ==  41) { ENT_CREATE (TEMP_STRING, SektorObjekt.X, SEKT_Schatten); }
									IF (SektorObjekt[7] ==  80) { ENT_CREATE (TEMP_STRING, SektorObjekt.X, SEKT_Feuer_klein); }
									IF (SektorObjekt[7] ==  90) { ENT_CREATE (TEMP_STRING, SektorObjekt.X, SEKT_Schwimmend); }
									IF (SektorObjekt[7] == 100) { ENT_CREATE (TEMP_STRING, SektorObjekt.X, ITEM_Schmetterling); }
									IF (SektorObjekt[7] == 110) { ENT_CREATE (TEMP_STRING, SektorObjekt.X, SEKT_Geister_a); }
									IF (SektorObjekt[7] == 120) { ENT_CREATE (TEMP_STRING, SektorObjekt.X, ITEM_Ladenschild); }
		
								}
							}
						}
		
						FILE_CLOSE (filehandle);
	
					} ELSE { Sektormatrix[TEMP] = 2; }	// Achtung, TEMP wird da drin veraendert ^^
				}

				PrePastShow[2] += 1;

			}

//			WAITT (24);
			TEMP = 0;
			WHILE (TEMP < Sektor_X * Sektor_Y) {
				IF (Sektormatrix[TEMP] == 2) { Sektormatrix[TEMP] = 1; } ELSE { Sektormatrix[TEMP] = 0; }
				TEMP += 1;
			}
//			Sektormatrix[TEMPs.Z] = 3;
			WAITT (4);
			show_sekt_load.VISIBLE = OFF;
		}
	WAITT (2);
	}

	TEMP[0] = NULL;
	WHILE (TEMP[0] < SektorObjekt.LENGTH) { SektorObjekt[TEMP[0]] = NULL; TEMP[0] += 1; }

}


entity* rayterra;
bmap rayalpha = <rayalpha.bmp>;

function SEKT_Raytracing()
{
var ausd;	// ausdehnung des Terrains
var count;	// Hauptschleife
var dens;	// Schattendichte
var format;	// bmap pointer
var pixel;	// pixeldaten
var vecFrom;
var vecTo;

YOU = ENT_NEXT(NULL);
	WHILE (YOU) {
		IF (YOU._charakter == 19) { rayterra = YOU; break; }
		YOU = ENT_NEXT (YOU);
	}

YOU = ENT_NEXT(NULL);
	WHILE (YOU) {
		YOU.PASSABLE = OFF;
		YOU = ENT_NEXT (YOU);
	}

format = bmap_lock(rayalpha, 0);

ausd.X = rayterra.MAX_X;	// 6160 / 128 = 48.125
ausd.Y = rayterra.MAX_Y;
ausd.Z = rayterra.Z - 512;

	WHILE (count.Y < 256) {
		WHILE (count.X < 256) {
			WHILE (dens.Y < 2) {
				WHILE (dens.X < 2) {
					vecFrom.X = count.X * (ausd.X / 128) - ausd.X + dens.X * (ausd.X / 256) + ausd.X / 512;
					vecFrom.Y = ausd.Y - count.Y * (ausd.Y / 128) - dens.Y * (ausd.Y / 256) - ausd.X / 512;
					vecFrom.Z = ausd.Z;
					C_TRACE (vecFrom.X, vector(vecFrom.X, vecFrom.Y, vecFrom.Z + 2048), IGNORE_PASSABLE + IGNORE_PASSENTS);
		
					VEC_SET (vecTo.X, TARGET.X);
		
					vecFrom.X = 2048; vecFrom.Y = NULL; vecFrom.Z = NULL;
					VEC_ROTATE (vecFrom.X, sun_angle.PAN);
					VEC_ADD (vecFrom.X, vecTo.X);
		
					RESULT = C_TRACE (vecFrom.X, vecTo.X, IGNORE_SPRITES);

					TEMP = VEC_DIST (vecFrom.X, vecTo.X);

					IF (YOU) { IF (YOU._charakter == 19) {
							IF (RESULT > TEMP * 0.85) { dens.X += 1; continue; }
					} }
		
					dens.Z += 1;

				dens.X += 1;
				}

				IF (dens.Z) {
					TEMP.RED = 256 - 32 * dens.Z; TEMP.GREEN = TEMP.RED; TEMP.BLUE = TEMP.RED;
					pixel = pixel_for_vec(TEMP, 0, format);
					pixel_to_bmap(rayalpha, count.X, count.Y, pixel);
				}


			dens.X = 0;
			dens.Y += 1;
			}

		VEC_SET (dens.X, NULLVECTOR);

		count.X += 1;
		}
	count.X = 0;
	count.Y += 1;

//	TEMPs.X += 1;
//	WAIT (1);
	}

bmap_unlock(rayalpha);
}

/*
PANEL raytracingzeugs
{
	POS_X 256;
	POS_Y 256;
	BMAP = rayalpha;
	LAYER = 1;
	FLAGS = VISIBLE;
}
*/

//on_f = SEKT_Datei_schreiben;
//on_g = SEKT_Sektoranalyse;
//on_h = SEKT_Raytracing;